package com.example.photowebcamshmeleff;


import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.os.Bundle;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.os.Handler;
import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import android.Manifest;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.ImageFormat;
import android.graphics.SurfaceTexture;
import android.hardware.camera2.CameraAccessException;
import android.hardware.camera2.CameraCaptureSession;
import android.hardware.camera2.CameraDevice;
import android.hardware.camera2.CameraManager;
import android.hardware.camera2.CaptureRequest;
import android.hardware.camera2.TotalCaptureResult;
import android.media.Image;
import android.media.ImageReader;
import android.os.Build;
import android.os.Environment;
import android.os.HandlerThread;
import android.os.Looper;
import android.os.Message;
import android.provider.Settings;
import android.text.Html;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.SpannableStringBuilder;
import android.text.method.LinkMovementMethod;
import android.text.method.ScrollingMovementMethod;
import android.text.style.ImageSpan;
import android.util.Log;
import android.view.Surface;
import android.view.TextureView;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.Arrays;
import static android.os.Environment.getStorageDirectory;
//-----------------------------------------------------------
// Это приложение было моей первой программой, написанной на JAVA для Android
// Несколько лет спустя приложение было модернизировано и предлагается в качестве
// шаблона (полнофункциональной основы) для Вашего приложения. Проверено на Android 10 и 11
//
// Photo Web Cam - фоторегистратор с загрузкой картинок на веб хостинг по FTP
//
// Приложение разрабатывалось для наблюдения за дачей. Можно наблюдать за магазином, квартирой,
// офисом, складом, стоянкой и т.д. Фотографии загружаются на любой хостинг (платный или бесплатный),
// имеющий FTP доступ. Фотографии можно просматривать в обычном вебброузере на смартфоне, планшете или ПК
// в любой точке мира. Для удобного просмотра есть шаблоны веб страниц на HTML и PHP
//
// Выбраны "старые" версии Android 10 и 11 преднамеренно. Такие б/у смартфоны уже сейчас стоят дёшево и их не жалко
// использовать в качестве Веб Камеры.
//
// На один хостинг можно загружать фотографии с любого количества Веб Камер, т.к. в FTP настройках Вы можете задать разные имена
// для серий фотографий.
//
// Описание приложения
//
// Приложение Photo Web Cam делает фотографии по расписанию. Вы можете выбрать фотокамеру, с которой делать фотографии,
// время суток (период) в которое делаются снимки (светлое время) и количество секунд между снимками (определяется скростью Интернета -
// временем загрузки фотографии на хостинг). В настройках задаются параметры FTP подключения - адрес FTP сервера (хостинга),
// логин, пароль и ПАПКА. Папка (folder, катлог) - это важный параметр. На многих хостингах ТОЧКА FTP ПОДКЛЮЧЕНИЯ (и, соответственно,
// загрузки файлов) не совпадает с папкой, в которой лежит файл index.htm (или index.html или index.php). Вам недо добавить
// некое смещение, чтобы фотографии грузилиь туда, откуда Ваш веб броузер их может просматривать. Ну или написать PHP файл (index.php), который
// будет их выбирать и отдавать вебброузеру.
//
// Например, для веб хостинга http://www.wallst.ru/ это смещение будет public_html
// Переменная private static String desDirectory = "public_html";
//
// В приложении есть кнопка |DARK|, которая делать темный экран (и восстанавливает его яркость). Это сделано для экономии энергии,
// ресурса экрана и уменьшения заметности работы приложения.
//
// Приложение имеет очень детальный |GUIDE|. Иллюстрации к настройке приложения можно посмотреть на http://oflameron.com
//
// FTP клиент реализован с использованием очень известных библиотек Apache FTP Client. В JAVA проекте для Android Studio есть
// файл README.docx в котором содержится дополнительная информация, иллюстации (в т.ч. показывающие как подключать библиотеки) и
// ссылки на ресурсы.
//
// При запуске приложение проверяется PING на IP-адрес Google и доступность FTP-сервера (хостинга). Это может занять время перед прорисовкой экрана.
//
// Предлагаемый JAVA проект для Android Studio полностью компилируемый. По мере обновления версий Android Studio и версий
// Android Вам может потребоваться вносить в приложение доработки. Для этого листинги максимально прокомментированы.
//
// Приложение не меняет настроек фотокамеры, использует те, которые уже выбраны в Android.
// Используется только вертикальная ориентация экрана
// Фотосъемка производится по жесткой циклограмме
// Время между снимками следует задавать исходя из скорости Интернета. Для WiFi или 5G время может быть около минуты.
//
// Проект компилировался в Android Studio Electric Eel | 2022.1.1 Patch 1
// Build #AI-221.6008.13.2211.9514443, built on January 21, 2023
// Runtime version: 11.0.15+0-b2043.56-9505619 amd64
// VM: OpenJDK 64-Bit Server VM by JetBrains s.r.o.
// Windows 10 10.0
//
// В проекте преднамеренно сохранено много LOG строк, использованных для отладки
//
// Проект прилагается "как есть". Вы можете разрабатывать на его основе свои приложениея и использовать в некоммерческих или коммерческих целях.
// Никаких авторских отчислений НЕ ТРЕБУЕТСЯ. Просьба указать ссылку (текст) на исходное приложение. Ничего более.
//
// Это первый из многих проектов с открытым исходным кодом ВЫСОКОЙ СТЕПЕНИ ГОТОВНОСТИ:
// - AudioREG - аудио рекордер (регистратор) с FTP клиентом
// - GPS/GSM_Treck - трекер с отправкой GPS и Network координат по SMS
// - CzechEntropyPRNG - программый генератор псевдослучайных чисел большой размерности (PRNG) высокого качества
// - BigIntPrimeNUMBER - программа "поиска" и отбора специальных пар простых чисел большой размерности
// - Пример приложения для работы с SQLite и RSA шифрованием данных
// - RSANotes или AESNotes - блокнот или приложение для записок с шифрованием (для паролей, PIN-кодов и т.д.)
// Ну и другие
//
// (c) by Valery Shmelev
// http://oflameron.com
// OFLAMERON
//


public class MainActivity extends AppCompatActivity  {


    public static final String LOG_TAG = "myLogs";
    private static final String TAG = "myLogs";
    public static String fullimagepath = "/storage/emulated/0/DCIM/test1.jpg";
    public static String localimagename = "1"; //Для записи в телеметрию имени локального файла

    CameraService[] myCameras = null;

    private CameraManager mCameraManager    = null;
    private final int CAMERA1   = 0;
    private final int CAMERA2   = 1;
    public int CAMERA   = 2; //Номер ВЫБРАННОЙ кнопкой фотокамеры

    private Button mButtonOpenCamera1 = null; // Выбор камеры 1
    private Button mButtonOpenCamera2 = null; //Выбор камеры 2
    private Button mButtonToMakeShot = null; //Сделать снимок
    private Button onButton3Local = null; //Сохранять снимки локально - кнопка


    private static TextureView mImageView = null;
    private HandlerThread mBackgroundThread;
    private Handler mBackgroundHandler = null;
    private Object view;
    private static final int REQUEST_ID_IMAGE_CAPTURE = 100;
    private static final int REQUEST_ID_VIDEO_CAPTURE = 101;
    private int CAMERA_CAPTURE;
    private com.example.photowebcamshmeleff.MyFTPClientFunctions ftpclient = null; // FTP клиент
    public int brightness; //Яркость экрана
    public int brightness2; // Текущая яркость экрана
    static int brightness3; // Текущая яркость экрана
    //----- Storage Permissions ------------------------------
    private static final int REQUEST_ID_READ_WRITE_PERMISSION = 99;
    //--------------------------------------------------------
    //Вызов таймера и обеспечение работоспособности ПРИ ВЫКЛЮЧЕНИИ смартфона
    //--------------------------------------------------------

    Timer timer;
    TimerTask mTimerTask;
    Timer timerTrig; // Запись телеметрии по таймеру
    TimerTask mTimerTaskTrig; // Запись телеметрии по таймеру
    public int TCounter   = 0; //Для таймера
    public int Dark   = 1; // Если =0 - тёмный экран. Если =1 - светлый экран
    public String STCounter = ""; //Для таймера
    public int TimePoint   = 1; //Триггер - вкл/выкл таймер
    public static int LocalImg   = 1; //Триггер - 1 = вкл. загрузку картинок на FTP сервер; 0 = сохранять картинки локально в смартфоне
    public static int TestJpgCount = 1; //Счетчик количества картинок при ЛОКАЛЬНОЙ записи в смартфон
    public static TextView ETextView; //Объявим TextView. Потом его найдем через  = findViewById(R.id.tableRow9);
    public TextView E8TextView; //Объявим TextView из FTPActivity. Потом его найдем через  = findViewById(R.id.tableRow9);
    private static String srcFilePath = "photosett.jpg";
    private static String desFileName = "photosett"; // ПЕРВАЯ часть имени картинки, к которой потом будем добавлять порядковый номер
    private static String desDirectory = "public_html"; // Каталог на FTP сервере для файла
    private static Context context = null;

    SharedPreferences sPref; // Для работы с Preferences - чтения или сохранения настроек. Как SETUP в FTPActivity
    private static String FTIME_TEXT ="500"; // Период между съемками
    private static String STIME_TEXT ="7"; // Время начало сессии
    private static String ETIME_TEXT ="20"; // Время окончания сессии
    private static String ftime = "500"; // Повтор съемки через столько секунд
    private static String stime = "7"; // Время суток начала сзмки в часах
    private static String etime = "20"; // Время суток окончания сзмки в часах
    public static Integer iftime = 400; // Повтор съемки через столько секунд
    private static Integer istime = 7; // Время суток начала сзмки в часах
    private static Integer ietime = 20; // Время суток окончания сзмки в часах
    public static String printTxtView = ""; // Переменная для вывода телеметрии в TextView
    public static String photonumber = "10"; //Количество фотографий в сессию - для формирования номера в названии файла
    public static Integer iphotonumber = 10; //Количество фотографий в сессию - для формирования номера в названии файла
    private static String FNAME_TEXT ="eoflameron"; // Имя для фотографий
    private static String INUMBER_TEXT ="10"; // Количество фотографий в сессии (в цикле), после чего они перезаписывабтся на сервере
    private static String FTP_TEXT ="ftpserver_string"; // Читаем имя FTP сервера из ресурсов
    public static String ftphost = "eeeeee"; //Имя FTP сервера, прочитанное из ресурсов
    private static String LOGIN_TEXT ="ftplogin_string"; // Читаем логин сервера из ресурсов
    public static String ftpusername = "username"; //Логин FTP сервера, прочитанное из ресурсов
    private static String PASSWORD_TEXT ="ftppassword_string"; // Читаем пароль сервера из ресурсов
    public static String ftppassword = "password"; //Логин FTP сервера, прочитанное из ресурсов
    private static String FOLDER_TEXT ="ftpfolder_string"; //Папка на FTP сервере, в которой точка входа броузера

    //----- Написать телеметрию -----------------------------
    public static String iprintTxtView = ""; //Текст, который показывается в телеметрии
    //----- Таймер для Записи Телеметрии --------------------
    public static int TeleTrigger = 0; // Не записывать в Телеиметрию по таймеру
    // Storage Permissions - Для API 23+ необходимо запросить разрешения на чтение / запись, даже если они уже есть в вашем манифесте
    private static final int REQUEST_EXTERNAL_STORAGE = 1;
    private static String[] PERMISSIONS_STORAGE = {
            Manifest.permission.READ_EXTERNAL_STORAGE,
            Manifest.permission.WRITE_EXTERNAL_STORAGE
    };
    //----- Background Thread -------------------------------
    private void startBackgroundThread() {
        mBackgroundThread = new HandlerThread("CameraBackground");
        mBackgroundThread.start();
        mBackgroundHandler = new Handler(mBackgroundThread.getLooper());
        Log.e(TAG, "==|private void startBackgroundThread|==: mBackgroundThread.start()" );
    }
    //-------------------------------------------------------
    private void stopBackgroundThread() {
        mBackgroundThread.quitSafely();
        try {
            mBackgroundThread.join();
            mBackgroundThread = null;
            mBackgroundHandler = null;
            Log.e(TAG, "==|private void stopBackgroundThread|==: mBackgroundHandler = null" );
        } catch (InterruptedException e) {
            e.printStackTrace();
            Log.e(TAG, "==|private void stopBackgroundThread|==: ERROR mBackgroundHandler = null" );
        }
    }
    //-------------------------------------------------------
    // Класс  для описания того, что будет происходить при работе таймера (задача для таймера):
    //-------------------------------------------------------
    class MyTimerTask extends TimerTask {
        public int Tcnt = 0; // Счетчик для 10 секунд
        @Override
        public void run() {
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    TCounter = TCounter +1;
                    STCounter = String.valueOf(TCounter);
                    //-------------------------------------------------------
                    //     Прочитать дату и время. Написать в TextView
                    //-------------------------------------------------------
                    // Текущее время
                    Date currentDate = new Date();
                    // Форматирование времени как "день.месяц.год"
                    DateFormat dateFormat = new SimpleDateFormat("dd.MM.yyyy", Locale.getDefault());
                    String dateText = dateFormat.format(currentDate);
                    // Форматирование времени как "часы:минуты:секунды"
                    DateFormat timeFormat = new SimpleDateFormat("HH", Locale.getDefault()); // Показывать только ЧАС
                    String timeText = timeFormat.format(currentDate);
                    timehandler.sendEmptyMessage(0); // Асинхронная запись текста на экран
                    Log.e(TAG, "==== Timer ====: " + STCounter); // Пишем значения счетчика
                    if(Integer.parseInt(timeText) > istime) {        // Если время больше istime часов утра (из ресурсов)
                        if (Integer.parseInt(timeText) < ietime) {        // Если время меньше ietime часа вечера (из ресурсов)
                            if (TCounter == 5) { // На 5-й секунде
                                //Обнулить счетчик секунд
                                if (CAMERA == 2) { // Если CAMERA=2 - не выбрана фотокамера кнопками, использовать по умолчанию тыльную фотокамеру
                                    mButtonOpenCamera1.performClick();
                                    CAMERA = 0; //Тыльная фотокамера
                                }
                            }
                            if (TCounter == 10) { // На 10-й секунде
                            }
                            if (TCounter == 15) { // На 15-й секунде
                                if (myCameras[CAMERA1].isOpen())
                                    myCameras[CAMERA1].makePhoto(); //Сделать снимок с тыльной фотокамеры
                                if (myCameras[CAMERA2].isOpen())
                                    myCameras[CAMERA2].makePhoto(); //Сделать снимок с лицевой фотокамеры
                                //-------------------------------------------------------
                            }
                            if (TCounter == 25) { // На 25-й секунде циклограммы
                                //Коннект к FTP серверу и запись файла
                                //-------------------------------------------------------
                                // Это исполнять только, если выбран режим загрузки на FTP сервер. Т.е. переменная LocalImg = 1
                                // Если LocalImg = 0 - то записывать картинки в ЛОКАЛЬНУЮ память смартфона
                                if (LocalImg == 1) {
                                    onFTP(); // Коннект к FTP серверу и запись файла
                                }
                                //-------------------------------------------------------
                            }
                            if (TCounter >= iftime) {     // ВРЕМЯ ПОВТОРА СНИМКОВ
                                //Обнулить счетчик секунд - перейти к следующему снимку
                                TCounter = 6; //Не открывать заново фотокамеру. Перейти ПОЗЖЕ
                                if (CAMERA == 0) { // Если CAMERA=0 - Была выбрана ТЫЛЬНАЯ фотокамера
                                    myCameras[CAMERA1].openCamera(); //Разблокирует превью перед следующим снимком
                                }
                                if (CAMERA == 1) { // Если CAMERA=0 - Была выбрана ЛИЦЕВАЯ фотокамера
                                    myCameras[CAMERA2].openCamera(); //Разблокирует превью перед следующим снимком
                                }
                            }
                        }
                    }
                    if (TeleTrigger == 1) { // Написать в Телеметрию
                        handler.sendEmptyMessage(0); // Асинхронная запись текста на экран
                        TeleTrigger = 0;
                    }

                }
            });
        }
    }
    // =========== End class MyTimerTask extends TimerTask ============



    //----- Что делает Таймер для Записи Телеметрии ---------
    class MyTimerTaskTrig extends TimerTask {
        @Override
        public void run() {
            runOnUiThread(new Runnable() {
                // Отображаем информацию в текстовом поле count:
                @Override
                public void run() {
                    if (TeleTrigger == 1) { // Написать в Телеметрию
                        handler.sendEmptyMessage(0); // Асинхронная запись текста на экран
                        TeleTrigger = 0;
                    }
                    Log.i(TAG, "================ (( T I M E R ))================ "); // Полный путь /storage/emulated/0/DCIM/test1.jpg
                }
            });
        }
    }
    // =========== End class MyTimerTaskTrig extends TimerTask ============




    //-------------------------------------------------------
    // Читаем данные (настройки) из Setup - FTP Activity
    // Если они не отправлены из FTPActivity, то будет пустая строка
    //-------------------------------------------------------
    @RequiresApi(api = Build.VERSION_CODES.M)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT); //Задать статично ориентацию экрана
        TextView etmtry = findViewById(R.id.TextView7e);
        etmtry.setMovementMethod(new ScrollingMovementMethod()); // Для прокрутки TextView с Телеметрией

        setTitle("PhotoWebCam"); // Название приложения на смартфоне
        ftpclient = new com.example.photowebcamshmeleff.MyFTPClientFunctions();

        Log.i(TAG, "====(( Write JPG - OK. Environment.FULL Path ))====: " + Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM) +"/test"+TestJpgCount+".jpg"); // Полный путь /storage/emulated/0/DCIM/test1.jpg
        context = this.getBaseContext();
        Log.i(TAG, "====(( Write JPG - OK. Context.FULL Path ))====: " + context.getExternalFilesDir(Environment.DIRECTORY_DCIM) +"/test"+TestJpgCount+".jpg"); // Полный путь /storage/emulated/0/DCIM/test1.jpg
        //==context.getExternalFilesDir(Environment.DIRECTORY_DCIM);
        verifyStoragePermissions(MainActivity.this); // Проверка разрешения на запись файла. Эта Активити
        //----- Создать запрос на раздерешение записи ---------------------
        if (Build.VERSION.SDK_INT >= 30){
            if (!Environment.isExternalStorageManager()){
                Intent getpermission = new Intent();
                getpermission.setAction(Settings.ACTION_MANAGE_ALL_FILES_ACCESS_PERMISSION);
                startActivity(getpermission);
            }
        }

        //----- Создать ссылку на Web Guide -------------------------------
        TextView elink = findViewById(R.id.webGuide); // Линк в нижнем TextView
        elink.setText(Html.fromHtml("&nbsp;&nbsp;<a href='https://themascc.com/?Android%20PhotoWebCam.apk%20Developer%20Valery%20Shmelev%20and%20Crypto%20PRNG%20app%20CzechEntropyPRNG.apk'><font color='#6200EE'><b> JOB! </b></font></a><br><br>",Html.FROM_HTML_MODE_LEGACY));
        elink.setMovementMethod(LinkMovementMethod.getInstance()); // Чтобы работал Click на Веб ссылке
        //-------------------------------------------------------
        // Прочитать из РЕСУРСОВ значения. Как в FTPActivity
        // ftime - через сколько повторять снимок - String
        // stime - время старта наблюдения        - String
        // etime - время окончания наблюдения     - String
        //-------------------------------------------------------
        sPref = getSharedPreferences("MyPref",MODE_PRIVATE); //с помощью метода getPreferences получаем объект sPref класса SharedPreferences
        if (sPref.getString(FTIME_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            ftime = sPref.getString(FTIME_TEXT, "").toString(); //Здесь - FTIME_TEXT - название переменной
            iftime = Integer.parseInt(ftime); //Конвертировать время повтора снимка ИЗ СТРОКИ в ЧИСЛО
            Log.d(TAG, "====[ iftime ]====: " + iftime.toString());
        }
        if (sPref.getString(STIME_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            stime = sPref.getString(STIME_TEXT, "").toString(); //Здесь - STIME_TEXT - название переменной
            istime = Integer.parseInt(stime); //Конвертировать время старта сессии ИЗ СТРОКИ в ЧИСЛО
            Log.d(TAG, "====[ istime ]====: " + istime.toString());
        }
        if (sPref.getString(ETIME_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            etime = sPref.getString(ETIME_TEXT, "").toString(); //Здесь - ETIME_TEXT - название переменной
            ietime = Integer.parseInt(etime); //Конвертировать время завершения сессии ИЗ СТРОКИ в ЧИСЛО
            Log.d(TAG, "====[ ietime ]====: " + ietime.toString());
        }
        if (sPref.getString(FNAME_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            desFileName = sPref.getString(FNAME_TEXT, "").toString(); //Здесь - FNAME_TEXT - название переменной - имя файла картинки
            Log.d(TAG, "====[ desFileName ]====: " + desFileName);
        }
        if (sPref.getString(INUMBER_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            photonumber = sPref.getString(INUMBER_TEXT, "").toString(); //Здесь - FNAME_TEXT - название переменной - количество картинок в сессии
            iphotonumber = Integer.parseInt(photonumber); //Конвертировать время завершения сессии ИЗ СТРОКИ в ЧИСЛО
            Log.d(TAG, "====[ iphotonumber ]====: " + iphotonumber.toString());
        }
        if (sPref.getString(FTP_TEXT, "FTP Server").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            ftphost = sPref.getString(FTP_TEXT, "FTP Server").toString(); //Здесь - FTP_TEXT - название переменной
            Log.d(TAG, "====[ FTP SERVER ADRESS ]====: " + ftphost.toString());
        }
        if (sPref.getString(LOGIN_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            ftpusername = sPref.getString(LOGIN_TEXT, "").toString(); //Здесь - LOGIN_TEXT - название переменной
            Log.d(TAG, "====[ FTP SERVER LOGIN ]====: " + ftpusername.toString());
        }
        if (sPref.getString(PASSWORD_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            ftppassword = sPref.getString(PASSWORD_TEXT, "").toString(); //Здесь - PASSWORD_TEXT - название переменной
            Log.d(TAG, "====[ FTP SERVER PASSWORD ]====: " + ftppassword.toString());
        }
        if (sPref.getString(FOLDER_TEXT, "").toString() == "") { //Если еще ничего не вводили, то показать из activity_f_t_p.xml
        } else {
            desDirectory = sPref.getString(FOLDER_TEXT, "").toString(); //Здесь - FOLDER_TEXT - название переменной
            Log.d(TAG, "====<<[ FTP FOLDER TEXT ]>>====: " + desDirectory.toString());
        }
        //----- Проверка доступности Интернет -----------------------------
        ping("8.8.8.8"); // PING 8.8.8.8 Для определения доступности INTERNET
        ifFTP(); //Проверка подключения к FTP серверу
        //-----------------------------------------------------------------

        //----- Работа с Таймером -----------------------------------------
        // Текущая яркость экрана
        //-----------------------------------------------------------------
        MainActivity f = new MainActivity(); // Экземпляр класса, для работы с его переменной brightness2
        try {
            f.brightness2 = android.provider.Settings.System.getInt(getContentResolver(),android.provider.Settings.System.SCREEN_BRIGHTNESS);
            f.brightness3 = android.provider.Settings.System.getInt(getContentResolver(),android.provider.Settings.System.SCREEN_BRIGHTNESS);
            //infoTextView.setText("Текущая яркость экрана: " + curBrightnessValue);
            Log.d(LOG_TAG, "============= ЯРКОСТЬ 2 ===============" + f.brightness2);
            Log.d(LOG_TAG, "============= ЯРКОСТЬ 3 ===============" + f.brightness3);

        } catch (Settings.SettingNotFoundException e) {
            e.printStackTrace();
        }
        context = getApplicationContext();
        Intent brightnessIntent = this.getIntent();
        float brightness = brightnessIntent.getFloatExtra("brightness value", f.brightness2);  //<-- 1-225
        WindowManager.LayoutParams lp = getWindow().getAttributes();
        lp.screenBrightness = brightness;
        getWindow().setAttributes(lp);
        //----- Не переходить к режиму SLEEP ------------------------------
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        //-----------------------------------------------------------------

        Log.d(LOG_TAG, "Запрашиваем разрешение");
        if (checkSelfPermission(Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED  //Есть ли разрешения на использование камеры
                ||
                (ContextCompat.checkSelfPermission(MainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED)
        )
        {
            requestPermissions(new String[]{Manifest.permission.CAMERA,Manifest.permission.WRITE_EXTERNAL_STORAGE},1); // Есть ли разрешение на использование хранилища
        }


        mButtonOpenCamera1 =  findViewById(R.id.button1); //Камера Передняя - находим по ID в activity_main.xml
        mButtonOpenCamera2 =  findViewById(R.id.button2); //Камера Задняя - находим по ID в activity_main.xml
        mButtonToMakeShot =findViewById(R.id.button3); //Сделать снимок - находим по ID в activity_main.xml
        mImageView = findViewById(R.id.textureView); //Здесь мы смотрим фото

        //----- Выбор Фотокамеры ------------------------------------------
        // Выбор фотокамеры
        mButtonOpenCamera1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (myCameras[CAMERA2].isOpen()) {myCameras[CAMERA2].closeCamera();}
                if (myCameras[CAMERA1] != null) {
                    if (!myCameras[CAMERA1].isOpen()) myCameras[CAMERA1].openCamera();
                    CAMERA = 0; //Выбрали кнопкой тыльную фотокамеру
                    Log.e(LOG_TAG,"== CAMERA = 0 ");
                }
            }
        });

        mButtonOpenCamera2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (myCameras[CAMERA1].isOpen()) {myCameras[CAMERA1].closeCamera();}
                if (myCameras[CAMERA2] != null) {
                    if (!myCameras[CAMERA2].isOpen()) myCameras[CAMERA2].openCamera();
                    CAMERA = 1; //Выбрали кнопкой лицевую фотокамеру
                    Log.e(LOG_TAG,"== CAMERA = 1 ");
                }
            }
        });


        mButtonToMakeShot.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v)
            {
                if (LocalImg == 1) { // =1 - значит можно записывать на FTP сервер
                    LocalImg = 0;    // =0 - значит записывать в ЛОКАЛЬНУЮ память смартфона
                    Log.d(TAG, "====[ Set LOCAL-YES ]==== ");
                    //----- Написать в Телеметрию -------------------------------
                    printTxtView = "USE Local storage ";
                    handler.sendEmptyMessage(0); // Write to Edit Text
                    //-----------------------------------------------------------
                } else {
                    LocalImg = 1;
                    Log.d(TAG, "====[ Set LOCAL-NO ]==== ");
                    //----- Написать в Телеметрию -------------------------------
                    printTxtView = "USE FTP storage ";
                    handler.sendEmptyMessage(0); // Write to Edit Text
                    //-----------------------------------------------------------
                }
            }
        });

        mCameraManager = (CameraManager) getSystemService(Context.CAMERA_SERVICE);
        try{
            // Получение списка камер с устройства
            myCameras = new CameraService[mCameraManager.getCameraIdList().length];
            for (String cameraID : mCameraManager.getCameraIdList()) {
                Log.i(LOG_TAG, "== cameraID: "+cameraID);
                int id = Integer.parseInt(cameraID);
                // создаем обработчик для камеры
                myCameras[id] = new CameraService(mCameraManager,cameraID);
            }
        }
        catch(CameraAccessException e){
            Log.e(LOG_TAG,"== CameraAccessException " + e.getMessage());
            e.printStackTrace();
        }
    } // OnCreate


    //----- Check Storage ---------------------------------------------
    public static void verifyStoragePermissions(Activity activity) {
        // Check if we have write permission
        int permission = ActivityCompat.checkSelfPermission(activity, Manifest.permission.WRITE_EXTERNAL_STORAGE);

        if (permission != PackageManager.PERMISSION_GRANTED) {
            // We don't have permission so prompt the user
            ActivityCompat.requestPermissions(
                    activity,
                    PERMISSIONS_STORAGE,
                    REQUEST_EXTERNAL_STORAGE
            );
            Log.e("== verifyStoragePermissions ==","== Storage == DON'T HAVE PERMISSION");
        }
    }

    //----- PING - проверка доступности INTERNET ----------------------
    public String ping(String url) {
        TextView etxtv = findViewById(R.id.TextView7e);
        String str = "";
        try {
            Process ipProcess = Runtime.getRuntime().exec("/system/bin/ping -c 1 8.8.8.8");
            int exitValue = ipProcess.waitFor();
            ipProcess.destroy();
            if(exitValue == 0){
                // Success
                printTxtView = " PING SUCCESS ";
                handler.sendEmptyMessage(0); // Write to Edit Text
                Log.d(TAG, "======| PING SUCCESS |======: ");
            } else {
                // Failure
                printTxtView = " PING FAILURE ";
                handler.sendEmptyMessage(0); // Write to Edit Text
                Log.d(TAG, "======| PING FAILURE |======: ");
            }
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
        return str;
    }

    //----- Прочитать настройки из РЕСУРСОВ ---------------------------
    public void ReadSETUP() { // Прочитать из РЕСУРСОВ
    } //


    //----- ФОТОКАМЕРА ------------------------------------------------
    public class CameraService { // Отдельный КЛАСС для работы с фотокамерой - как в https://habr.com/ru/post/468083/
        // Путь и имя файла с фото
        private File mFile = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM), "test"+TestJpgCount+".jpg");;
        private String mCameraID;
        private CameraDevice mCameraDevice = null;
        private CameraCaptureSession mCaptureSession;
        private ImageReader mImageReader;

        public CameraService(CameraManager cameraManager, String cameraID) {
            mCameraManager = cameraManager;
            mCameraID = cameraID;
        }

        //----- Сделать ФОТО ----------------------------------------------
        public void makePhoto (){
            try {
                // This is the CaptureRequest.Builder that we use to take a picture.
                final CaptureRequest.Builder captureBuilder =
                        mCameraDevice.createCaptureRequest(CameraDevice.TEMPLATE_STILL_CAPTURE);
                captureBuilder.addTarget(mImageReader.getSurface());

                if (CAMERA == 0) {  //Тыльная фотокамера
                    captureBuilder.set(CaptureRequest.JPEG_ORIENTATION, 90); //Если тыльная фотокамера
                }
                if (CAMERA == 1) { //Лицевая фотокамера
                    captureBuilder.set(CaptureRequest.JPEG_ORIENTATION, 270); //Если лицевая фотокамера
                }

                CameraCaptureSession.CaptureCallback CaptureCallback = new CameraCaptureSession.CaptureCallback() {

                    @Override
                    public void onCaptureCompleted(@NonNull CameraCaptureSession session,
                                                   @NonNull CaptureRequest request,
                                                   @NonNull TotalCaptureResult result) {
                        printTxtView = "Capture Completed ";
                        handler.sendEmptyMessage(0); // Write to Edit Text
                    }
                };

                mCaptureSession.stopRepeating(); //Остановка чтения изображения с фотокамеры ???? - НЕТ
                mCaptureSession.abortCaptures();
                mCaptureSession.capture(captureBuilder.build(), CaptureCallback, mBackgroundHandler);
            }
            catch (CameraAccessException e) {
                Log.i(LOG_TAG, "==| Make Photo Error |== - CaptureRequest.Buildewr ");
                e.printStackTrace();

            }
        }


        private final ImageReader.OnImageAvailableListener mOnImageAvailableListener  // Слушаем, когда имидж будет готов
                = new ImageReader.OnImageAvailableListener() {

            @Override
            //----- Когда ФОТО готово -----------------------------------------
            public void onImageAvailable(ImageReader reader) {
                mBackgroundHandler.post(new ImageSaver(reader.acquireNextImage(), mFile));
                //============ Написать в телеметрию ===============
                printTxtView = "Image test " + localimagename + ".jpg Ready - OK";
                handler.sendEmptyMessage(0); // Write to Edit Text
                //==================================================
                Log.i(LOG_TAG, "==| onImageAvailable |==  - Image Ready - OK ");
            }

        };

        //-------------------------------------------------------------
        // Как только камера готова, срабатывает этот коллбэк
        //
        // То есть, ФОТОКАМЕРА ОТКРЫТА и может что-то там делать: выводить
        // изображение с камеры на вьюшку, пересылать его дальше для сохранения и так далее.
        //-------------------------------------------------------------
        private CameraDevice.StateCallback mCameraCallback = new CameraDevice.StateCallback() { // CallBACK

            @Override // Здесь вся работа с фотокамерой после того, как она сатала ОТКРЫТА
            public void onOpened(CameraDevice camera) { // Когда фотокамера ОТКРЫТА и может что-то там делать: выводить изображение с камеры на вьюшку, пересылать его дальше для сохранения и так далее.
                mCameraDevice = camera;
                Log.i(LOG_TAG, "== Open camera  with id:"+mCameraDevice.getId()); //Какая камера будет использована
                printTxtView = " Cam Open Success "; // Текст в Телеметрию
                handler.sendEmptyMessage(0); // Write to Edit Text

                createCameraPreviewSession();
            }

            @Override
            public void onDisconnected(CameraDevice camera) { // ЗАКРЫТЬ фотокамеру по DISCONNECT
                mCameraDevice.close(); //Освободить камеру
                //============ Написать в телеметрию ===============
                printTxtView = "Close PhotoCamera" + " " + mCameraDevice.getId();
                handler.sendEmptyMessage(0); // Write to Edit Text
                //==================================================
                Log.i(LOG_TAG, "==| Camera Close |== - onDisconnect camera  with id:"+mCameraDevice.getId());
                mCameraDevice = null;
            }

            //----- Обработка ошибок ------------------------------------------
            @Override
            public void onError(CameraDevice camera, int error) {
                Log.i(LOG_TAG, "==| Error |== camera id:"+camera.getId()+" error:"+error); //Обработка ошибки работы с камерой
                printTxtView = " Cam Open Error ";
                handler.sendEmptyMessage(0); // Write to Edit Text
            }
        };

        //----- Camera 2 API ----------------------------------------------
        // Для работы с фотокамерой использован механизм Camera 2 API. Примеры можно найти как "Android Java Camera 2 API"
        // https://sidstudio.com.ua/sidstudio-blog/razrabotka-android-prilozheniy-dlya-lollipop-ispolzuya-camera2-api-chast-2
        // https://github.com/hzitoun/android-camera2-secret-picture-taker
        // https://coderoad.ru/28003186/Захват-изображения-без-предварительного-просмотра-с-помощью-camera2-API  - здесь есть новые листинги Camera 2 API
        private void createCameraPreviewSession() {

            mImageReader = ImageReader.newInstance(1920,1080, ImageFormat.JPEG,1);
            // Класс ImageReader обеспечивает прямой
            // доступ приложения к данным изображения, отображаемым в поверхности
            // Если задавать формат изображения JPG, бужет низкий FPS
            mImageReader.setOnImageAvailableListener(mOnImageAvailableListener, null); // Интерфейс обратного вызова для получения уведомления о доступности нового изображения

            Log.i(TAG, "====(( Write JPG - OK. FULL Path ))====: " + Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM) +"/test"+TestJpgCount+".jpg"); // Полный путь /storage/emulated/0/DCIM/test1.jpg

            SurfaceTexture texture = mImageView.getSurfaceTexture();
            Log.i(LOG_TAG, "====| == | GET SURFACE TEXTURE | == |====");

            texture.setDefaultBufferSize(1920,1080); // 1920,1080
            Surface surface = new Surface(texture); //Создаем Surface

            Log.i(LOG_TAG, "==| Create Surface |== in createCameraPreviewSession()");
            //-- Записать в Телеметрию ---------------
            printTxtView = " Surface Create Success ";
            handler.sendEmptyMessage(0); // Write to Edit Text
            //----------------------------------------
            try {
                final CaptureRequest.Builder builder =

                        mCameraDevice.createCaptureRequest(CameraDevice.TEMPLATE_PREVIEW);

                builder.addTarget(surface);

                // Для того, чтобы можно было просматривать или делать снимки, необходимо создать сессию для работы с камерой. У выбранной камеры необходимо вызвать метод createCaptureSession()
                // Описание https://sidstudio.com.ua/sidstudio-blog/razrabotka-android-prilozheniy-dlya-lollipop-ispolzuya-camera2-api-chast-2
                // ОТЛИЧНАЯ СТАТЬЯ по CAMERA2 API - https://xakep.ru/2016/03/29/android-hidden-shooting/
                mCameraDevice.createCaptureSession(Arrays.asList(surface,mImageReader.getSurface()),
                        new CameraCaptureSession.StateCallback() {

                            @Override
                            public void onConfigured(CameraCaptureSession session) { // Здесь надо делать снимок
                                mCaptureSession = session;
                                try {
                                    mCaptureSession.setRepeatingRequest(builder.build(),null,mBackgroundHandler);
                                    Log.i(LOG_TAG, "==| 000000 private void onConfigured |== Camera Capture Session Success ");
                                } catch (CameraAccessException e) {
                                    Log.i(LOG_TAG, "==| private void onConfigured |== Camera Capture Session Error ");
                                    e.printStackTrace();
                                }
                            }

                            //----- Обработка ошибок ------------------------------------------
                            @Override
                            public void onConfigureFailed(CameraCaptureSession session) { }}, mBackgroundHandler);
            } catch (CameraAccessException e) {
                Log.i(LOG_TAG, "== | private void createCameraPreviewSession | == onConfigureFailed ");
                e.printStackTrace();
            }

        }

        //----- http://oflameron.com --------------------------------------
        public boolean isOpen() { // Проверка - ФОТОКАМЕРА уже ОТКРЫТА ?
            if (mCameraDevice == null) {
                Log.i(LOG_TAG, "==| mCamera isOpen - False |==");
                return false;
            } else {
                Log.i(LOG_TAG, "==| mCamera isOpen - True |==");
                return true;
            }
        }

        @RequiresApi(api = Build.VERSION_CODES.M)
        public void openCamera() {
            try {

                if (checkSelfPermission(Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) {
                    mCameraManager.openCamera(mCameraID,mCameraCallback,mBackgroundHandler);
                    Log.i(LOG_TAG, "==| OpenCamera - OK |==");
                    //============ Написать в телеметрию ===============
                    printTxtView = "OpenCamera Num="+mCameraID+" OK";
                    handler.sendEmptyMessage(0); // Write to Edit Text
                    //==================================================
                }
            } catch (CameraAccessException e) {
                Log.i(LOG_TAG, "==| OpenCamera - Error |==");
                Log.i(LOG_TAG,e.getMessage());
                printTxtView = " Cam Access Exception ";
                handler.sendEmptyMessage(0); // Write to Edit Text
            }
        }

        public void closeCamera() { // ЗАКРЫТЬ фотокамеру
            Log.i(LOG_TAG, "==| CloseCamera |==");
            if (mCameraDevice != null) {
                mCameraDevice.close();
                mCameraDevice = null;
                Log.i(LOG_TAG, "==|public void closeCamera|== Camera Close - Close + Null ");
                //---- Написать в Телеметрию -------------------
                printTxtView = "Cam Close ";
                handler.sendEmptyMessage(0); // Write to Edit Text
                //----------------------------------------------
            }
        }
    } //class CameraService


    @Override
    public void onPause() { // Cam onPause
        Log.i(LOG_TAG, "==| Camera - public void onPause |== ");
        if(myCameras[CAMERA1].isOpen()){myCameras[CAMERA1].closeCamera();}
        if(myCameras[CAMERA2].isOpen()){myCameras[CAMERA2].closeCamera();}
        stopBackgroundThread();
        super.onPause();
        Log.i(LOG_TAG, "==|public void onPause|== ");
    }

    @Override
    public void onResume() { // Cam onResume
        Log.i(LOG_TAG, "====|public void onResume|====");
        super.onResume();
        startBackgroundThread();
    }


    //----- Написать телеметрию ----------------------------
    Handler handler = new Handler(Looper.getMainLooper()) { // Print Text on screen
        @Override
        public void handleMessage(Message msg) {
            TextView sxTelenetry = findViewById(R.id.TextView7e); // Написать телеметрию
            sxTelenetry.append(printTxtView + "\n");
        }
    }; // Handler

    //----- Написать Таймер ----------------------------
    Handler timehandler = new Handler(Looper.getMainLooper()) { // Print Text on screen
        @Override
        public void handleMessage(Message msg) {
            String WebGuide = " &nbsp;&nbsp;<a href='https://themascc.com/?Android%20PhotoWebCam.apk%20Developer%20Valery%20Shmelev%20and%20Crypto%20PRNG%20app%20CzechEntropyPRNG.apk'><font color='#6200EE'><b> JOB! </b></font></a>" + "&nbsp;&nbsp;&nbsp;&nbsp;<b>" + STCounter.toString() + " sec</b><br><br>";
            TextView elink = findViewById(R.id.webGuide); // Линк в нижнем TextView
            elink.setText(Html.fromHtml(WebGuide,Html.FROM_HTML_MODE_LEGACY));
        }
    }; // Handler


    //----- Class ImageSaver ------------------------------------------
    public static class ImageSaver implements Runnable { // Специальный объект класса ImageSaver, который перекачает данные с картинки в байтовый буфер, а оттуда уже в бинарный файл
        // Этот класс статический да ещё и Runnable. Поэтому мы его размещаем в самой MainActivityFirst f = new First();
        /**
         * The JPEG image
         */

        private final Image mImage;
        /**
         * The file we save the image into.
         */
        private final File mFile;
        private int TestJpgCount2 = 1; //Для отображения в телеметрию имени локального файла картинки

        ImageSaver(Image image, File file) {
            mImage = image;
            mFile = file;
        }


        //----- Запись файла ФОТОГРАФИИ -----------------------------------
        @Override
        public void run() {
            Log.i(LOG_TAG, "==| ImageFileWrite |== - public void run()");
            ByteBuffer buffer = mImage.getPlanes()[0].getBuffer();
            byte[] bytes = new byte[buffer.remaining()];
            buffer.get(bytes);
            FileOutputStream output = null;
            try {

                output = new FileOutputStream(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM) +"/test"+TestJpgCount+".jpg");
                output.write(bytes);
                TestJpgCount2 = TestJpgCount + 1;
                localimagename = ""+ TestJpgCount2 +""; // Для записи в телеметрию правильного имени локального файла картинки
                Log.i(TAG, "====(((( Write JPG - OK. FULL Path ))))====: " + Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM) +"/test"+TestJpgCount+".jpg"); // Полный путь /storage/emulated/0/DCIM/test1.jpg

                printTxtView = "Write Image " + localimagename;
                TeleTrigger = 1; // Разрешить написать в Телеметрию по Таймеру
                //---------------------------------------------
                if (LocalImg == 0) { //Если =0 , то писать в ЛОКАЛЬНУЮ память смартфона
                    TestJpgCount = TestJpgCount + 1;
                    printTxtView = "Local Write Image " + localimagename;
                    TeleTrigger = 1; // Разрешить написать в Телеметрию по Таймеру
                    if (TestJpgCount == 51) {
                        TestJpgCount = 1; //Для записи test1.jpg в ЛОКАЛЬНУЮ память смартфона 50 фотографий
                    }
                    Log.i(TAG, "====||||| f.LocalImg == |||||==" + LocalImg);
                    Log.i(TAG, "====||||| f.TestJpgCount == |||||==" + TestJpgCount);
                }
                //---------------------------------------------
            } catch (IOException e) {
                printTxtView = "Error write JPG file IOException";
                TeleTrigger = 1; // Разрешить написать в Телеметрию по Таймеру
                Log.i(TAG, "==| Error write JPG file IOException e |==");
                e.printStackTrace();
            } finally {
                mImage.close();
                if (null != output) {
                    try {
                        output.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    //----- Показать FTP Activity ---------------------------------------------
    public void onButton4Click(View view) {
        Intent intent = new Intent(MainActivity.this, FTPActivity.class);
        Log.i(TAG, "==| onButton4Click |==");
        startActivity(intent);
    }

    //----- Показать GUIDE ---------------------------------------------
    public void onButtonGuide(View view) {
        Intent intent = new Intent(MainActivity.this, PrintActivity.class);
        Log.i(TAG, "==| onButtonGuide |==");
        startActivity(intent);

    }


    //----- Сделать ТЕМНЫЙ/СВЕТЛЫЙ экран ------------------------------
    public void onButton4eClick(View view) {
        MainActivity h = new MainActivity(); // Экземпляр класса, для работы с его переменной brightness2

        if (Dark == 1) {
            Dark = 0; // Сделать темный экран
            LinearLayout bgElement = (LinearLayout) findViewById(R.id.MainForm);
            bgElement.setBackgroundColor(Color.BLACK);
            Intent brightnessIntent = this.getIntent();
            float brightness = brightnessIntent.getFloatExtra("brightness value", Dark);  // =0 - тёмный экран, =1 - светлый экран <-- 1-225
            WindowManager.LayoutParams lp = getWindow().getAttributes();
            lp.screenBrightness = brightness;
            getWindow().setAttributes(lp);
        } else {
            Dark = 1; // Сделать светлый экран
            LinearLayout bgElement = (LinearLayout) findViewById(R.id.MainForm);
            bgElement.setBackgroundColor(Color.parseColor("#fdf5e6")); //Цвет фона MAIN PAGE в activity_main.xml
            Intent brightnessIntent = this.getIntent();
            Log.d(LOG_TAG, "============= ЯРКОСТЬ UP ===============" + brightness3);
            float brightness = brightnessIntent.getFloatExtra("brightness value", brightness3);  // =0 - тёмный экран, =1 - светлый экран <-- 1-225
            WindowManager.LayoutParams lp = getWindow().getAttributes();
            lp.screenBrightness = brightness;
            getWindow().setAttributes(lp);
        }
    }


    //----- Выйти из приложения ---------------------------------------
    public void onButton5Click(View arg0) {
        moveTaskToBack(true);
        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(1);

    }


    public void onButtonClick(View view) { // START/STOP
        // Остановить/Запустить таймер
        Button button = (Button)findViewById(R.id.button1e); // Кнопка с ID STOP
        Button buttonlocal = (Button)findViewById(R.id.button3); // Кнопка с ID button3 - MAKE LOCAL
        Button buttonfrontcam = (Button)findViewById(R.id.button1); // Кнопка с ID button1 - FRONT CAM
        Button buttonrearcam = (Button)findViewById(R.id.button2); // Кнопка с ID button2 - REAR CAM
        Button buttonftpsetting = (Button)findViewById(R.id.button4); // Кнопка с ID button4 - FTP SETTING
        Button buttondark = (Button)findViewById(R.id.button4e); // Кнопка с ID button4e - DARK
        Button buttonGuide = (Button)findViewById(R.id.buttonGuide); // Кнопка GUIDE на Main Activity

        // Отключить кнопку \MAKE LOCAL\ - выбранный режим сохранения больше менять нельзя
        buttonlocal.setEnabled(false); // Отключить кнопку CAM Local
        buttonfrontcam.setEnabled(false); // Отключить кнопку FRONT CAM
        buttonrearcam.setEnabled(false); // Отключить кнопку REAR CAM
        buttonftpsetting.setEnabled(false); // Отключить кнопку FTP SETTING

        // Цвет кнопки \DARK\
        if (TimePoint == 0) {
            // button.setText("Timer Stoped");
            timer.cancel();
            timer = null;
            Log.i(TAG, "==== Timer STOPED ===="); // Пишем сообщение в Телеметрию
            printTxtView = "Timer STOPED";
            handler.sendEmptyMessage(0); // Write to Edit Text
            TimePoint = 1;
        } else {
            timer = new Timer();
            mTimerTask = new MyTimerTask();
            timer.schedule(mTimerTask, 1000, 1000);
            Log.i(TAG, "==== Timer STARTED ===="); // Пишем сообщение в Телеметрию
            printTxtView = "Timer STARTED";
            handler.sendEmptyMessage(0); // Write to Edit Text
            TimePoint = 0;
            //====================================================
            Log.d(LOG_TAG, "==| SETUP Read |== ");
            ReadSETUP(); // Прочитать параметры SETUP  из РЕСУРСОВ
            Log.d(LOG_TAG, "==| SETUP Reading |== ");
            //============ Написать в телеметрию ===============
            printTxtView = "ftime=" + iftime.toString();
            handler.sendEmptyMessage(0); // Write to Edit Text
            printTxtView = "stime=" + istime.toString();
            handler.sendEmptyMessage(0); // Write to Edit Text
            printTxtView = "etime=" + ietime.toString();
            handler.sendEmptyMessage(0); // Write to Edit Text
            printTxtView = "desFileName=" + desFileName;
            handler.sendEmptyMessage(0); // Write to Edit Text
            printTxtView = "photonumber=" + photonumber;
            handler.sendEmptyMessage(0); // Write to Edit Text
            printTxtView = "Download http://oflameron.com";
            handler.sendEmptyMessage(0); // Write to Edit Text
            //==================================================

        } // http://oflameron.com
    }

    //----- Проверка доступности FTP подключения  ---------------------
    // В Log.d пишет есть доступ к FTP или нет.
    public void ifFTP() {
        MyFTPClientFunctions onftpcl = new MyFTPClientFunctions();
        final MainActivity h = new MainActivity(); // Экзнмпляр класса MainActivity


        Thread ftpThread = new Thread( // создаём новый поток
                new Runnable() { // Описываем объект Runnable в конструкторе
                    @Override
                    public void run() {
                        boolean status = false;
                        status = ftpclient.ftpConnect(ftphost, ftpusername, ftppassword, 21);
                        if (status == true) {
                            Log.d(TAG, "====== FTP Connection Success ======");
                            printTxtView = " FTP Connect Success ";
                            handler.sendEmptyMessage(0); // Write to Edit Text
                        } else {
                            Log.d(TAG, "====== FTP Connection Failed ======");
                            printTxtView = " FTP Connect Failed ";
                            handler.sendEmptyMessage(0); // Write to Edit Text
                        }
                    }
                }
        );
        ftpThread.start(); //Запустить поток

        if (ftpThread != null) { // Остановить поток
            Thread dummy = ftpThread;
            ftpThread = null;
            dummy.interrupt();
        }
    }


    //----- Подключиться к FTP серверу --------------------------------
    //   (Вызов из другого класса - MyFTPClientFunctions - файл MyFTPClientFunctions.java
    public void onFTP() {  //onButton5Click(View view) {
        MyFTPClientFunctions ftpcl = new MyFTPClientFunctions();
        final String path2 = getApplicationInfo().dataDir; //Путь к каталогу приложения - myTextView.setText(path); - РАБОТАЕТ

        new Thread(new Runnable() {
            @RequiresApi(api = Build.VERSION_CODES.R)
            public void run() {
                boolean status = false;
                status = ftpclient.ftpConnect(ftphost, ftpusername, ftppassword, 21);
                if (status == true) {
                    Log.d(TAG, "== == Connection Success == == ");
                    srcFilePath = MainActivity.fullimagepath; //Полный путь к КАРТИНКЕ получен из MainActivitty из переменной
                    ftpclient.ftpUpload(srcFilePath, desFileName, desDirectory, context, iphotonumber); //Здесь последний параметр - photonumber - количество фотографий в сессию
                    Log.d(TAG, "== == (((( SUCCESS Source Path File )))) = " + srcFilePath);
                    Log.d(TAG, getStorageDirectory().toString());  //Написать текущий каталог
                } else {
                    Log.d(TAG, "== == Connection failed == == ");
                }
                printTxtView = "FTP Upload Image to " + desDirectory + "/" + desFileName + ftpcl.nnum + ".jpg\n" + ftpcl.printTxtViewFTP; // Написать статус загрузки на FTP сервер
                TeleTrigger = 1; // Разрешить написать в Телеметрию по Таймеру
            }
        }).start();
    }

    //----- TextView добавить Image --------------------------------------------
    public void TextViewImages() { // TextView добавить Image
        TextView textViewImage = (TextView) findViewById(R.id.TextView7e);
        SpannableStringBuilder spannableStringBuilder = new SpannableStringBuilder();
        spannableStringBuilder.append(" Hello Text ");
        ImageSpan imageSpan1 = new ImageSpan(this, R.drawable.cze);
        SpannableString spannableString2 = new SpannableString(" ");
        spannableString2.setSpan(imageSpan1, spannableString2.length() - 1, spannableString2.length(), Spannable.SPAN_INCLUSIVE_EXCLUSIVE);
        spannableStringBuilder.append(spannableString2);
        spannableStringBuilder.append(" Text for TextView");
        spannableStringBuilder.append(spannableString2);
        textViewImage.setText(spannableStringBuilder);
    }
} // MainActivity class